package main

import (
	"fmt"
	"log"
	"os"
	"sync"
)

var config Config

func main() {
	var err error

	config.load()
	fmt.Printf("%+v\n", config)

	args := []string{""}
	if len(os.Args) > 0 {
		args = os.Args[1:]
	}

	curr, err := pickRandomImage(args[0])
	if err != nil {
		log.Fatal("failed to pick image!", err)
	}

	hyprpaperSet(curr)

	var waitGroup sync.WaitGroup
	waitGroup.Add(1)
	go server(&waitGroup)
	waitGroup.Wait()
}
